﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Microsoft.Win32;

namespace CopyTo
{
    public partial class frmmain : Form
    {
        private RegistryKey root = Registry.ClassesRoot;

        private string sKey = @"AllFilesystemObjects\shellex\ContextMenuHandlers\CopyTo";
        private string sClsid = "{C2FBB630-2971-11D1-A18C-00C04FD75D13}";

        private void Install()
        {
            //Key to read sKey
            RegistryKey rKey = root.OpenSubKey(sKey);

            //Check if the key is found
            if (rKey == null)
            {
                try
                {
                    //Not found install the new key
                    rKey = root.CreateSubKey(sKey);
                    //Set the CLSID key default value
                    rKey.SetValue(string.Empty, sClsid);
                    //Display finish message
                    MessageBox.Show("Done", "Install", MessageBoxButtons.OK,
                        MessageBoxIcon.Information);
                }
                catch (UnauthorizedAccessException)
                {
                    MessageBox.Show("Error installing.\nYou may need to run this program as administrator."
                        , "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                }
            }
            else
            {
                MessageBox.Show("Already installed.", "Install",
                    MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
        }

        private void Uninstall()
        {
            //Check if key is installed
            RegistryKey rKey = root.OpenSubKey(sKey);

            //Check if the key is found
            if (rKey != null)
            {
                try
                {
                    //Delete the key
                    root.DeleteSubKey(sKey);
                    //Display finish message
                    MessageBox.Show("Done", "Uninstall", MessageBoxButtons.OK,
                        MessageBoxIcon.Information);
                }
                catch (UnauthorizedAccessException)
                {
                    MessageBox.Show("Error uninstalling.\nYou may need to run this program as administrator."
                        , "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                }
            }
            else
            {
                MessageBox.Show("Not installed.", "Uninstall",
                    MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
        }

        public frmmain()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            Install();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            Uninstall();
        }

        private void cmdExit_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void frmmain_Load(object sender, EventArgs e)
        {

        }
    }
}
